node {
  //get the commit-Id to use it after to tag the generated image
   def commit_id
   
   stage('Preparation') {
     //get the source code of the application
     git credentialsId: 'gitlab-repo', url: 'https://gitlab.com/youssefhammoud/jenkins-nodejs.git'
     sh "git rev-parse --short HEAD > .git/commit-id"
     commit_id = readFile('.git/commit-id').trim()
     echo "${commit_id}"
   }
   
   stage('test') {
    //use the agent nodejs as container to run and test the application
     def myTestContainer = docker.image('node:14')
     myTestContainer.pull()
     myTestContainer.inside {
          //sh 'make all'
          sh 'pwd'
          sh 'make all'
     }
   }
   
   stage('code coverage') {
       sh 'pwd'
     // generate code coverage link 
      publishHTML([allowMissing: false, alwaysLinkToLastBuild: false, keepAll: false, reportDir: 'coverage', reportFiles: 'index.html', reportName: 'Code Coverage link', reportTitles: ''])
    }
    
   stage('sonarqube') {
     //configure the sonarqubeplugin to check the quality management of the application
      def sonarqubeScannerHome = tool name: 'sonar', type: 'hudson.plugins.sonar.SonarRunnerInstallation'
      withCredentials([string(credentialsId: 'sonar', variable: 'sonarLogin')]) {
        sh "${sonarqubeScannerHome}/bin/sonar-scanner -e -Dsonar.host.url=http://sonarqube:9000  -Dsonar.login=${sonarLogin} -Dsonar.projectName=parts-store-cli -Dsonar.projectVersion=${env.BUILD_NUMBER} -Dsonar.projectKey=parts-store-cli  -Dsonar.sources=.  -Dsonar.css.node=. -Dsonar.exclusions=src/**/*.spec.js -Dsonar.test=src/**/*.spec.js -Dsonar.exclusions=**/javascripts/dist/*.js,**/javascripts/vendor/*.js,**/stylesheets/*.css  -Dsonar.language=node:14 "
      }
 }

   stage('docker build/push') {  
     //build and push the application  as docker container      
     docker.withRegistry('https://index.docker.io/v1/', 'dockerhub') {
      def app = docker.build("youssefhammoud/docker-nodejs-demo:${commit_id}", '.').push()
     }                                     
  }             
}
